{$M 1024,0,0}
TYPE
  Font8x8 = ARRAY[1..2048] OF Byte;

VAR
  Font : Font8x8;

PROCEDURE Bold_FONT;     EXTERNAL; {$L BOLD.OBJ}
PROCEDURE Cyrilic_FONT;  EXTERNAL; {$L CYR.OBJ}
PROCEDURE Italic_FONT;   EXTERNAL; {$L ITAL.OBJ}
PROCEDURE Small_FONT;    EXTERNAL; {$L SMALL.OBJ}
PROCEDURE Standart_FONT; EXTERNAL; {$L STD.OBJ}
PROCEDURE Thin_FONT;     EXTERNAL; {$L THIN.OBJ}
PROCEDURE Tiny_FONT;     EXTERNAL; {$L TINY.OBJ}


 PROCEDURE GetFontAccess; ASSEMBLER;
 ASM
        MOV     DX, $03C4; { Sequenser }
        MOV     AX, $0402;      OUT     DX, AX
        MOV     AX, $0704;      OUT     DX, AX

        MOV     DX, $03CE;
        MOV     AX, $0204;      OUT     DX, AX
        MOV     AX, $0005;      OUT     DX, AX
        MOV     AX, $0406;      OUT     DX, AX
 END;

 PROCEDURE ReleaseFontAccess; ASSEMBLER;
 ASM
        MOV     DX, $03C4; { Sequenser }
        MOV     AX, $0302;      OUT     DX, AX
        MOV     AX, $0304;      OUT     DX, AX

        MOV     DX, $03CE; { Graphic }
        MOV     AX, $0004;      OUT     DX, AX
        MOV     AX, $1005;      OUT     DX, AX

        MOV     AX, $0E06
        OUT     DX, AX
 END;

 PROCEDURE SetFont8x8(Table:Byte; VAR Font:Font8x8); ASSEMBLER;
 ASM
        CALL    GetFontAccess
        PUSH    DS
        LDS     SI, Font

        MOV     AX, $A000
        MOV     ES, AX
        XOR     AL, AL
        MOV     AL, Table
        MOV     CX, $4000
        MUL     CX
        MOV     DI, AX
        MOV     CX, $FF

 @LoadFONT:
        PUSH    CX
        PUSH    DI
        MOV     CX, 8
        REP     MOVSB

        MOV     AL, 0
        MOV     CX, 24
        REP     STOSB

        POP     DI
        POP     CX
        ADD     DI, 32
        LOOP    @LoadFONT

        CALL    ReleaseFontAccess
        POP     DS
 END;


VAR
  St   : STRING;
  Param: Char;


BEGIN
  St    := ParamStr(1);
  Param := UpCase(St[1]);
  CASE Param OF
    'B': Move(@Bold_FONT^    ,Font,2048);
    'C': Move(@Cyrilic_FONT^ ,Font,2048);
    'H': Move(@Thin_FONT^    ,Font,2048);
    'I': Move(@Italic_FONT^  ,Font,2048);
    'M': Move(@Small_FONT^   ,Font,2048);
    'S': Move(@Standart_FONT^,Font,2048);
    'T': Move(@Tiny_FONT^    ,Font,2048);
    ELSE BEGIN
           Writeln('FNT8x8 v1.0 by The GodFather'#13#10);
           Writeln('  Usage: FNT8x8 [b|c|h|i|m|s|t]'#13#10);
           Writeln('     b - BOLD');
           Writeln('     c - CYRILIC');
           Writeln('     h - THIN');
           Writeln('     i - ITALIC');
           Writeln('     m - SMALL');
           Writeln('     s - STANDART');
           Writeln('     t - TINY');
          Halt;
         END;
  END;
  SetFont8x8(0,Font);
END.